# Add project specific ProGuard rules here.
# You can control the set of applied configuration files using the
# proguardFiles setting in build.gradle.
#
# For more details, see
#   http://developer.android.com/guide/developing/tools/proguard.html

# If your project uses WebView with JS, uncomment the following
# and specify the fully qualified class name to the JavaScript interface
# class:
#-keepclassmembers class fqcn.of.javascript.interface.for.webview {
#   public *;
#}

# Uncomment this to preserve the line number information for
# debugging stack traces.
#-keepattributes SourceFile,LineNumberTable

# If you keep the line number information, uncomment this to
# hide the original source file name.
#-renamesourcefileattribute SourceFile

# 四个过程
-dontshrink                                # 不进行压缩操作，默认情况下，除了-keep配置（下详）的类及其直接或间接引用到的类，都会被移除。
-dontoptimize                              # 不对class进行优化，默认优化。由于优化会进行类合并、内联等多种优化，-applymapping可能无法完全应用，需使用热修复的应用，建议使用此配置关闭优化。
#-dontobfuscate                             # 不对代码名称进行混淆，这样类名称就不会混淆了，默认是混淆，sdk最好混淆
#-dontpreverify                             # 不对 class 进行预校验，默认校验，校验 StackMap /StackMapTable 属性。android不需要进行此步骤，可以加快混淆速度

-optimizationpasses 5                      # 指定压缩级别
-optimizations !code/simplification/arithmetic,!field/*,!class/merging/*   # 混淆时采用的算法(google推荐，一般不改变)

-useuniqueclassmembernames                 # 把混淆类中的方法名也混淆了
-dontskipnonpubliclibraryclasses           # 不路过引用库中的非public类
-dontskipnonpubliclibraryclassmembers      # 不跳过非公共的库的类成员
#-allowaccessmodification                   # 优化时允许访问并修改有修饰符的类和类的成员，此项会将混淆文件所在路径全部混淆。
#-ignorewarnings                            # 指定输出所有警告信息，但继续进行混淆。同上一选项，慎用。
#-dontwarn                                  # 指定一组类，不警告这些类中找不到引用或其它重要的问题。这个选项是很危险的，比如，找不到引用的错误可能导致代码不能正常work。

-keepattributes Exceptions                 # 不混淆异常
-keepattributes InnerClasses               # 不混淆内部类
-keepattributes Signature                  # 不混淆泛型
-keepattributes EnclosingMethod            # 不混淆反射
-keepattributes *Annotation*               # 不混淆注解
#-keepattributes Deprecated                 # 不混淆废弃类
#-keepattributes Synthetic                  #
#-keepattributes LocalVariable*Table        #
-keepattributes SourceFile,LineNumberTable # 抛出异常时保留代码和行号
#-keepattributes *JavascriptInterface*      # 不混淆JS调用java的方法
#-renamesourcefileattribute SourceFile       # 将文件来源重命名为“SourceFile”字符串

## normal

## 业务

# 对外类不混淆
-keep class com.bokecc.room.ui.manager.InteractSessionManager {
    public *;
}
-keep class com.bokecc.room.ui.view.activity.InspectorRoomActivity {
    public *;
}
-keep class com.bokecc.room.ui.view.activity.StudentRoomActivity {
    public *;
}
-keep class com.bokecc.room.ui.view.activity.TeacherRoomActivity {
    public *;
}

## 业务