[TOC]
## 合规指南

##### 1 合规说明

（1）请务必在《隐私政策》中告知，使用了场景视频sdk，格式如下：

使用SDK名称：xxSDK

服务类型：云直播/云点播/云课堂

收集个人信息类型及作用：

| 个人信息类型   | 作用                                             |
| -------------- | ------------------------------------------------ |
| 设备型号       | 用户设备型号，针对性的对设备调优                 |
| 操作系统版本   | 用户设备的操作系统，并针对系统进行调优           |
| 唯一设备标识符 | 用户生成的用户唯一标识符，并针对性的进行设备调优 |
| IP地址         | 用户的IP地址，针对性进行网络调优                 |
| 网络类型       | 根据不同网络类型，给用户进行使用提示             |
| 用户行为日志   | 用于解决用户使用中的异常问题                     |

（2）请务必做延迟初始化配置，确保用户授权《隐私政策》后再初始化sdk；

（3）单独成文：用户进入app点击4次以内就能访问到《隐私策略》；

（4）不得默认勾选“同意”，需用户自主选择；

（5）需要罗列出app采集的个人信息及权限，对个人敏感信息类型进行显著标识（加粗/加星/下划线）,不得出现“等”字眼，穷尽列举；

（6）需要罗列出app及第三方采集个人信息数据的类型和目的，不可出现模糊说明；

（7）如提供定向推荐功能，须在《隐私政策》中告知用户。

（8）如采集儿童类数据，须在《隐私政策》中特殊披露，并说明儿童数据的采集与保护情况。

（9）必须给出明确的注销路径及受理时间，最长15个工作日；

##### 2 相关问题说明

| 问题类型             | 解决方案                                                     |
| -------------------- | ------------------------------------------------------------ |
| 违规收集用户个人信息 | 1.私自收集个人信息问题：在《隐私政策》中向用户明示App、SDK手机个人信息的类型与目的。2.超范围手机个人信息问题：确保数据采集均与服务功能相关，所涉及个人信息字段均在《隐私政策》公示并得到用户授权。 |
| 违规使用用户个人信息 | 1.私自共享个人信息给第三方问题：在《隐私政策》向用户告知共享第三方的数据类型及目的，如增加友盟SDK标准隐私条款。 2.强制用户使用定向推送功能的问题：在《隐私政策》中告知用户定向推荐功能，在定向推荐页面进行显著标识，并提供关闭定向推荐的选项 |
| 不合理索取用户权限   | 1.不给权限，不让用问题：在《隐私政策》中披露App采集权限及目。用户拒绝，与App功能无关的权限，不得闪退App。 2.频繁申请权限问题：用户拒绝权限后不宜频繁（48小时内）再申请。 3.过度索取权限问题：不得采集与App功能无关的权限 |
| 为账号注销设置障碍   | 提供账号注销渠道，15个工作日内响应注销。账号注销时需要用户提供的信息，不得超过用户注册及使用App期间所提供的信息 |

##### 3 权限说明

| 权限名称                                                     | 权限含义                                          | 申请原因                                                     |
| :----------------------------------------------------------- | ------------------------------------------------- | ------------------------------------------------------------ |
| android.permission.INTERNET                                  | 允许程序访问网络连接，可能产生 GPRS 流量          | 与其他端互动交流，需要网络传输                               |
| android.permission.ACCESS_NETWORK_STATE                      | 允许获取网络信息状态                              | 获取当前网络用于优化数据包发送包策略，以便获得更好的音视频流畅体验 |
| android.permission.ACCESS_WIFI_STATE                         | 允许获取当前 Wi-Fi 接入的状态以及 WLAN 热点的信息 | 的状态以及 WLAN 热点的信息 获取当前 Wi-Fi 状态用于优化数据包发送包策略，以便获得更好的音视频流畅体验 |
| android.permission.WRITE_EXTERNAL_STORAGE android.permission.READ_EXTERNAL_STORAGE | 允许程序读取和写入外部存储                        | 存储 SDK 配置文件和日志文件                                  |
| android.permission.BLUETOOTH android.permission.BLUETOOTH_ADMIN | 允许应用程序发现并连接到蓝牙设备配对              | 需要支持蓝牙设备的接入                                       |
| android.permission.CAMERA android.hardware.camera android.hardware.camera.autofocus glEsVersion="0x00020000" android:required="true" | 允许程序访问摄像头                                | 用于采集摄像头画面，与其他使用者进行交互                     |
| android.permission.ACCESS_COARSE_LOCATION android.permission.ACCESS_FINE_LOCATION" | 获取信号强度及位置                                | 针对用户信号强度及大致位置进行调优                           |
| android.permission.READ_PHONE_STATE                          | 获取手机状态                                      | 读取设备型号，系统版本，判断是否为模拟器 通话状态和移动网络信息：通话状态是SDK在音视频通话时，可能会被系统的通话打断；移动网络信息是为了获取ip、mac这些信息，和服务器做互通； |
| android.permission.WAKE_LOCK                                 | 防止锁屏                                          | 防止直播过程中手机锁屏                                       |
| android.permission.RECORD_AUDIO                              | 麦克风相关权限                                    | 用于采集音频画面，与其他使用者进行交互                       |
| android.permission.MODIFY_AUDIO_SETTINGS"                    | 修改音频设置                                      | SDK在通话过程中，会对系统底层的一些设置项做改动，如音频路由、媒体音量/通话音量等项 |
